#ifdef __PRIVATE__
//#
//#	File:		ShapeB.idl
//#
//#	Contains:	ODBaseShape class: Geometric shapes for layout.
//#
//#	Written by:	Jens Alfke
//#
//#	Copyright:	c 1993-94 by Apple Computer, Inc., all rights reserved.
//#
//#	Change History (most recent first):
//#
//#		 <4>	  9/9/94	jpa		Descend from ODRefCntObject. [1185660]
//#		 <3>	 8/17/94	jpa		Added "functionprefix" directive. [1181512]
//#		 <2>	  8/8/94	jpa		Added Outset, NewShape, Reset [1178690,
//#									1179574]
//#		 <1>	  6/8/94	jpa		first checked in
//#		 <2>	  6/7/94	jpa		Tweaked more params.
//#
//#	To Do:
//#
#else
//#	Copyright:	c 1993-1994 by Apple Computer, Inc., all rights reserved.
#endif

#ifndef _SHAPEB_
#define _SHAPEB_

#ifndef _REFCTOBJ_
#include "RefCtObj.idl"  
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

interface ODBaseShape;

//==============================================================================
// Classes used in this interface
//==============================================================================

interface ODShape;
interface ODTransform;
interface ODStorageUnit;

//=====================================================================================
// Implementation Types
//=====================================================================================

#ifdef __PRIVATE__
typedef somToken RealShape;
#endif


//==============================================================================
// ODBaseShape
//==============================================================================

interface ODBaseShape :  ODRefCntObject
{
	
	//#---------------------------------
	//# factories:

	ODShape			NewShape();
    ODShape			Copy();

	//#---------------------------------
	//# getters/setters
	
	ODGeometryMode	GetGeometryMode();
	void			SetGeometryMode(in ODGeometryMode mode);
	void			GetBoundingBox(out ODRect bounds);
	ODShape			SetRectangle(in ODRect rect);
	ODPolygon		CopyPolygon();
	ODShape			SetPolygon(in ODPolygon polygon);
	ODPlatformShape	GetPlatformShape(in ODGraphicsSystem graphicsSystem);
	void			SetPlatformShape(in ODGraphicsSystem graphicsSystem,
									  in ODPlatformShape platformShape);
	void			Reset();
	
	//#---------------------------------
	//# input / output:
	
	void			WriteShape(in ODStorageUnit storageUnit);
	ODShape			ReadShape(in ODStorageUnit storageUnit);
	
	//#---------------------------------
	//# comparison/testing functions
	
	ODBoolean		IsSameAs(in ODShape compareShape);
	ODBoolean		IsEmpty();
	ODBoolean		ContainsPoint(in ODPoint point);
	ODBoolean		IsRectangular();
	ODBoolean		HasGeometry();
	
	//#---------------------------------
	//# geometry operations
	
	void		CopyFrom(in ODShape sourceShape);
	ODShape		Transform(in ODTransform transform);
	ODShape		InverseTransform(in ODTransform transform);
	ODShape		Subtract(in ODShape diffShape);
	ODShape		Intersect(in ODShape sectShape);
	ODShape		Union(in ODShape unionShape);
	ODShape		Outset( in ODCoordinate distance );
	  
#ifdef __PRIVATE__

	void		InitBaseShape();
	RealShape*  GetRealShape( );
  
#endif
#ifdef __SOMIDL__
	implementation
	{
		override:
			somInit,
			somUninit,
			Release;
			
		releaseorder:
			SetGeometryMode,
			GetGeometryMode,
			GetBoundingBox,
			SetRectangle,
			CopyPolygon,
			SetPolygon,
			GetPlatformShape,
			SetPlatformShape,
			WriteShape,
			ReadShape,
			IsSameAs,
			IsEmpty,
			ContainsPoint,
			IsRectangular,
			HasGeometry,
			Copy,
			CopyFrom,
			Transform,
			InverseTransform,
			Subtract,
			Intersect,
			Union,
			Outset,
			NewShape,
			Reset,
		#ifdef __PRIVATE__
			InitBaseShape,
			GetRealShape;
		#else
			reserved1,
			reserved2;
		#endif
		
		#ifdef __PRIVATE__
		passthru C_xh = "
		""
		"class RealShape;"
		"";

		RealShape*   fShape;
		ODGeometryMode  fMode;
		#endif
			
		majorversion = 1; minorversion = 0;
		
		functionprefix = ODBaseShape;
		
	};
#endif
};

#endif // _SHAPE_
